/*
 * CAN_protocol.h
 *
 * Created: 27.04.2015 15:34:12
 *  Author: vebjornr
 */ 


#ifndef CAN_PROTOCOL_H_
#define CAN_PROTOCOL_H_


#define BUTTONS_ID 0x01
#define SPEED_ID 0x0A
#define GPS_ID 0x14
#define MOTOR_ID 0x1E

#define CAN_MASK 0x7FF 

/*
											/// BUTTONS /////

Buttons are active low. (0 means button is pressed)

		 [  bit 7  |  bit 6  |  bit 5  |  bit 4  |  bit 3  |  bit 2  |  bit 1  |  bit 0  ]
		 
byte 0:  [blink l  | blink r | dead 1  | dead  2 |  horn   |  jow sw | lights1 | lights 2]
byte 1:  [ phone   | wiper   | angeleye|eyebrows |   n/a   |  n/a    |  n/a    |  n/a    ]
byte 2:  [ 8 joy_y msb]
byte 3:  [ 2 joy_y lsb]


	can_msg.data[0] |= (buttons->blink_left << 7);
	can_msg.data[0] |= (buttons->blink_right << 6);
	can_msg.data[0] |= (buttons->dead_mans_1 << 5);
	can_msg.data[0] |= (buttons->dead_mans_2 << 4);
	can_msg.data[0] |= (buttons->horn << 3);
	can_msg.data[0] |= (buttons->joy_sw << 2);
	can_msg.data[0] |= (buttons->lights_far << 1);
	can_msg.data[0] |= (buttons->lights_near << 0);
	
	can_msg.data[1] |= (buttons->phone << 7);
	can_msg.data[1] |= (buttons->wiper << 6);
	
	can_msg.data[2] = buttons->joy_y;
	can_msg.data[3] = (buttons->joy_y >> 8);
	
	can_msg.data[4] = buttons->volume;
	can_msg.data[5] = (buttons->volume >> 8);
	
	can_msg.data[6] = buttons->fans;
	can_msg.data[7] = (buttons->fans >> 8);


*/


#endif /* CAN_PROTOCOL_H_ */