/*
 * USART.c
 *
 * Created: 02.07.2013 17:52:25
 *  Author: Ole
 */ 

#include <avr/io.h>
#include <inttypes.h>

void usart0_init (unsigned int baud){
	
	/*	Set baud rate	*/
	UBRR0H = (unsigned char) (baud>>8);
	UBRR0L = (unsigned char) baud;
	
	/*	Set frame format: 8data, no parity & 1 stop bit	*/
	UCSR0C = (0<<UMSEL0) | (0<<UPM0) | (0<<USBS0) | (3<<UCSZ0);
	
	/*	Enable receiver and transmitter	*/
	UCSR0B = (1<<RXEN0) | (1<<TXEN0) | (1<<RXCIE0);
}

void usart1_init (unsigned int baud){
	/*
	Set baud rate
	*/
	UBRR1H = (	unsigned char	) (baud>>8);
	UBRR1L = (	unsigned char	) baud;
	
	/*
	Set frame format: 8data, no parity & 1 stop bit
	*/
	UCSR1C = (0<<UMSEL1) | (0<<UPM1) | (3<<UCSZ10);
	/*
	Enable receiver and transmitter
	*/
	UCSR1B = (1<<RXEN1) | (1<<TXEN1);
}

void usart0_putc (unsigned char data){
	/*
	Wait for empty transmit buffer
	*/
	while( !( UCSR0A & (1<<UDRE0)));
	/*
	Put data into buffer, sends the data
	*/
	UDR0 = data;
}

void usart1_putc (unsigned char data){
	/*
	Wait for empty transmit buffer
	*/
	while( !( UCSR1A & (1<<UDRE1)));
	/*
	Put data into buffer, sends the data
	*/
	UDR1 = data;
}

void usart0_puts(const char *s )
{
	while (*s)
	usart0_putc(*s++);

}

void usart1_puts(const char *s )
{
	while (*s)
	usart1_putc(*s++);

}

unsigned char usart0_getc(void)
{
	/*
	Wait for data to be received
	*/
	while	( ! (UCSR0A & (1<<RXC0)));
	/*
	Get and return received data from buffer
	*/
	return	UDR0;
}

unsigned char usart1_getc(void)
{
	/*
	Wait for data to be received
	*/
	while	( ! (UCSR1A & (1<<RXC1)));
	/*
	Get and return received data from buffer
	*/
	return UDR1;
}


/*
unsigned char usart0_receive(char *str, unsigned char size, unsigned char endChar)
{
	unsigned char i = 0;
	if (size == 0)
	{
		return 0;
	}
	
	while (i < size - 1)
	{
		unsigned char c = usart0_receive();
		if (c == endChar) break;
		str[i] = c;
		i++;
	}
	return i + 1;
}

unsigned char usart1_receive(char *str, unsigned char size, unsigned char endChar)
{
	unsigned char i = 0;
	if (size == 0)
	{
		return 0;
	}
	
	while (i < size - 1)
	{
		unsigned char c = usart1_receive();
		if (c == endChar) break;
		str[i] = c;
		i++;
	}
	return i + 1;
}
*/

