/*
 * adc.c
 *
 * Created: 10.04.2015 18:14:37
 *  Author: vebjornr
 */ 

#include <avr/io.h>
#include "adc.h"
#include "definitions.h"

void adc_init(void){
	
	ADMUX |= (1 << REFS0); // AVdd as reference, with external capacitor on Aref	
	ADCSRA |= (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1); //enable adc, set prescaler on frequency to 64 (125kHz)
}

uint16_t adc_read(adc_input_t adc){
	

	ADMUX &= ~(0x1F); // clear 5 lower bits of ADMUX
	
	switch(adc){
		case FANS: {ADMUX |= 0x03; break;} // ADC3
		case VOLUME: {ADMUX |= 0x00; break;} // ADC0
		case JOY_X: {ADMUX |= 0x01; break;} // ADC1
		case JOY_Y: {ADMUX |= 0x02; break;} //ADC2 
		
	}
	
	ADCSRA |= (1<<ADSC); // start conversion
	
	while(get_bit(ADCSRA, ADSC)); // wait until ADSC is set to 0
	
	uint16_t result = ADCL + (ADCH << 8);
	
	return result;
	
}