/*
 * rpi2_hat.c
 *
 * Created: 09.04.2015 17:20:49
 *  Author: vebjornr
 */ 


#include "definitions.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "can.h"
#include "USART.h"
#include "leds.h"

//CAN interrupt function prototypes
void can_read_buttons(CAN_packet *p, unsigned char mob);
void can_read_speed(CAN_packet *p, unsigned char mob);


uint8_t speed_counter = 0;
uint8_t button_counter = 0;


int main(void)
{
	can_init();
	leds_init();
	usart0_init(MYUBRR); 
	sei(); // enable global interrupts
	set_led(GREEN, ON);
	
	// start listening for can packets
	prepare_rx(1, 0x01, 0x7FF, can_read_buttons);
	prepare_rx(2, 0x0A, 0x7FF, can_read_speed);
	
    while(1)
    {
        //TODO:: Please write your application code 
		//toggle_led(GREEN);
		//toggle_led(RED);
		_delay_ms(1000);
    }
}

void can_read_buttons(CAN_packet *p, unsigned char mob){
	
	// limit the mcu to only send every fifth buttons-packet
	button_counter++;
	if (button_counter < 5)
	{
		return;
	}
	button_counter = 0;
	
	usart0_putc(254);
	usart0_putc(0x01);
	usart0_putc(254);
	
	for (int i=0; i<p->length; i++)
	{
		usart0_putc(p->data[i]);
	}
	usart0_putc(255);
	usart0_putc('\n');
	//toggle_led(GREEN);
	
	
}

void can_read_speed(CAN_packet *p, unsigned char mob){
	
	// limit the mcu to only send every fifth speed-packet
	speed_counter++;
	if (speed_counter < 5)
	{
		return;
	}
	speed_counter = 0;
	
	usart0_putc(254);
	usart0_putc(253);
	usart0_putc(254);
	
	for (int i=0; i<p->length; i++)
	{
		usart0_putc(p->data[i]);
	}
	usart0_putc(255);
	usart0_putc('\n');
	
	
}

ISR(USART0_RX_vect)
{
	// Code to be executed when the USART receives a byte here
	
	
}