/*
 * buttons.c
 *
 * Created: 10.04.2015 19:18:30
 *  Author: vebjornr
 */ 

#include "buttons.h"
#include "definitions.h"
#include "adc.h"
#include "can.h"
#include "USART.h"
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>


uint8_t angel_eyes = 1;
uint8_t eyebrows = 1;
uint8_t can_change_angel_eyes = 1;
uint8_t can_change_eyebrows = 1;
int16_t joy_x_offset = 0;
int16_t joy_y_offset = 0;
int16_t joy_x_center = 0;
int16_t joy_y_center = 0;


uint8_t button_is_pressed(uint8_t button){
	
	if (button == 1)
	{
		return 0;
	} else {
		return 1;
	}
	
}


void calibrate_joysticks(void){
	
	joy_x_center = 0;
	for (uint8_t i = 0; i<8; i++)
	{
		joy_x_center += adc_read(JOY_X);
	}
	joy_x_center = joy_x_center >> 3;
	
	joy_y_center = 0;
	for (uint8_t i = 0; i<8; i++)
	{
		joy_y_center += adc_read(JOY_Y);
	}
	joy_y_center = joy_y_center >> 3;
	
	joy_x_offset = joy_x_center - JOYSTICK_CENTER;
	joy_y_offset = joy_y_center - JOYSTICK_CENTER;
	/*
	for(int i=0; i<1023; i++){
		
		if(i<joy_x_center){
			joy_x_lookup[i] = i + (float)joy_x_offset*( ((float)i)/((float)joy_x_center));
			
		}else if(i == joy_x_center){
			joy_x_lookup[i] = JOYSTICK_CENTER;
		} else {
			joy_x_lookup[i] = i - (float)joy_x_offset*( ((float)i)/((float)joy_x_center));
		}
		
		if(i<joy_y_center){
			joy_y_lookup[i] = i + (float)joy_y_offset*( ((float)i)/((float)joy_y_center));
			
			}else if(i == joy_y_center){
			joy_y_lookup[i] = JOYSTICK_CENTER;
			} else {
			joy_y_lookup[i] = i - (float)joy_y_offset*( ((float)i)/((float)joy_y_center));
		}
		
		
	}
	*/
	
	
	//char lol[32];
	//sprintf(lol, "%d %d\n", joy_x_center, joy_y_center);
	//usart0_puts(lol);
	
}

void buttons_send_on_can(buttons_t *buttons){
	
	CAN_packet can_msg = {STEERING_WHEEL_ID, 8, {}};
		
	can_msg.data[0] |= ((buttons->blink_left & 0x01) << 7);
	can_msg.data[0] |= ((buttons->blink_right & 0x01) << 6);
	can_msg.data[0] |= ((buttons->dead_mans_1 & 0x01) << 5);
	can_msg.data[0] |= ((buttons->dead_mans_2 & 0x01) << 4);
	can_msg.data[0] |= ((buttons->horn & 0x01) << 3);
	can_msg.data[0] |= ((buttons->joy_sw & 0x01) << 2);
	can_msg.data[0] |= ((buttons->lights_far & 0x01) << 1);
	can_msg.data[0] |= ((buttons->lights_near & 0x01) << 0);
	
	can_msg.data[1] |= ((buttons->phone & 0x01) << 7);
	can_msg.data[1] |= ((buttons->wiper & 0x01) << 6);
	can_msg.data[1] |= ((buttons->angel_eyes & 0x01) << 5);
	can_msg.data[1] |= ((buttons->eyebrows & 0x01) << 4);
	can_msg.data[1] |= ((buttons->brake & 0x01) << 3);
	
	if(button_is_pressed(buttons->brake)) { // the driver is braking, set torque reference to 0
		buttons->joy_y = JOYSTICK_CENTER;
	}
	
	can_msg.data[2] = buttons->joy_y >> 2;
	can_msg.data[3] = (buttons->joy_y & 0x03);
	
	can_msg.data[4] = buttons->volume >> 2;
	can_msg.data[5] = (buttons->volume & 0x03);
	
	can_msg.data[6] = buttons->fans >> 2;
	can_msg.data[7] = (buttons->fans & 0x03);
	
	//try to send on all MOBs
	for (int i=0; i<1; i++)
	{
		if (can_tx(i, &can_msg))
		{
			break;
		}
		_delay_ms(5);
	}
	
}

uint16_t check_joy_value(int16_t joy_value, adc_input_t joy){

	/*
	if(joy == JOY_X){
		
		joy_value -= joy_x_offset;
		joy_value = INVERT_X_AXIS ? 1023 - joy_value : joy_value;
				
	} else if(joy == JOY_Y){
		char lol[32];
		sprintf(lol, "fr: %d\n", joy_value);
		usart0_puts(lol);
		joy_value -= joy_y_offset;
		joy_value = INVERT_Y_AXIS ? 1023 - joy_value : joy_value;
		sprintf(lol, "etter: %d\n", joy_value);
		usart0_puts(lol);
	}
	*/
	
	/*
	if(joy == JOY_X){
		if (joy_value < JOYSTICK_CENTER + joy_x_offset + JOYSTICK_CENTER_PADDING && joy_value > JOYSTICK_CENTER - joy_x_offset - JOYSTICK_CENTER_PADDING)
		{
			joy_value = JOYSTICK_CENTER;
		}
	}else if (joy == JOY_Y)
	{
		if (joy_value < JOYSTICK_CENTER + joy_y_offset + JOYSTICK_CENTER_PADDING && joy_value > JOYSTICK_CENTER - joy_y_offset - JOYSTICK_CENTER_PADDING)
		{
			joy_value = JOYSTICK_CENTER;
		}
	}
	*/
	
	
	if(joy == JOY_X){
		
		if(joy_value >= joy_x_center - JOYSTICK_CENTER_PADDING && joy_value <= joy_x_center + JOYSTICK_CENTER_PADDING){
			
			joy_value = JOYSTICK_CENTER;
		} else if(joy_value < joy_x_center - JOYSTICK_CENTER_PADDING){
		
		joy_value = joy_value - (((joy_x_center - JOYSTICK_CENTER) * (joy_value)) / joy_x_center);
		
		} else {
		joy_value = joy_value - (((joy_x_center - JOYSTICK_CENTER) * (1023-joy_value)) / joy_x_center);
		
		joy_value = INVERT_X_AXIS ? 1023 - joy_value : joy_value;
	}
		
	} else if(joy == JOY_Y){
		//char lol[32];
		//sprintf(lol, "fr: %d\n", joy_value);
		//usart0_puts(lol);
		if(joy_value >= joy_y_center - JOYSTICK_CENTER_PADDING && joy_value <= joy_y_center + JOYSTICK_CENTER_PADDING){
			
			joy_value = JOYSTICK_CENTER;
			
		} else if(joy_value < joy_y_center - JOYSTICK_CENTER_PADDING){
			
			joy_value = joy_value - (((joy_y_center - JOYSTICK_CENTER) * (joy_value)) / joy_y_center);
			
		} else {
			joy_value = joy_value - (((joy_y_center - JOYSTICK_CENTER) * (1023-joy_value)) / joy_y_center);
		}
		//sprintf(lol, "etter: %d\n", joy_value);
		//usart0_puts(lol);
		
		joy_value = INVERT_Y_AXIS ? 1023 - joy_value : joy_value;
	}

	
	if(joy_value < 0) return 0;
	else if(joy_value > 1023) return 1023;	
	else return joy_value;
}

void buttons_read(buttons_t *buttons){
	
	buttons->blink_left = get_bit(PINB, PB0) >> PB0;
	buttons->blink_right = get_bit(PINB, PB3) >> PB3;
	
	#ifdef DEAD_MANS_SWITCH
	buttons->dead_mans_1 = get_bit(PINE, PE3) >> PE3;
	buttons->dead_mans_2 = get_bit(PIND, PD3) >> PD3; 
	#else
	buttons->dead_mans_1 = 0x00; // pretend that both are pressed
	buttons->dead_mans_2 = 0x00;
	#endif
	
	buttons->horn = get_bit(PIND, PD0) >> PD0;
	buttons->joy_sw = get_bit(PIND, PD1) >> PD1;
	buttons->lights_far = get_bit(PINB, PB2) >> PB2;
	buttons->lights_near = get_bit(PINB, PB1) >> PB1;
	buttons->phone = get_bit(PINE, PE4) >> PE4;
	buttons->wiper = get_bit(PINE, PE5) >> PE5;
	buttons->brake = get_bit(PIND, PD2) >> PD2;

	buttons->volume = adc_read(VOLUME);
	buttons->fans = adc_read(FANS);
	
	buttons->joy_x = check_joy_value(adc_read(JOY_X), JOY_X);
	buttons->joy_y = check_joy_value(adc_read(JOY_Y), JOY_Y);
	//buttons->joy_x = adc_read(JOY_X);
	//buttons->joy_y = adc_read(JOY_Y);
	
	if(CAR == URBAN){
		//set angel-eyes
		if (buttons->joy_x > 1000)
		{
			if (angel_eyes == 1 && can_change_angel_eyes)
			{
				angel_eyes = 0;
				can_change_angel_eyes = 0;
			} else if (angel_eyes == 0 && can_change_angel_eyes)
			{
				angel_eyes = 1;
				can_change_angel_eyes = 0;
			}
		}
		if (buttons->joy_x < 530)
		{
			can_change_angel_eyes = 1;
		}
		buttons->angel_eyes = angel_eyes;
	
		// set eyebrows
		if (buttons->joy_x < 10)
		{
			if (eyebrows == 1 && can_change_eyebrows)
			{
				eyebrows = 0;
				can_change_eyebrows = 0;
			} else if (eyebrows == 0 && can_change_eyebrows)
			{
				eyebrows = 1;
				can_change_eyebrows = 0;
			}
		}
		if (buttons->joy_x > 480)
		{
			can_change_eyebrows = 1;
		}
		buttons->eyebrows = eyebrows;
	} else if(CAR == PROTOTYPE){
		
		
		
		
	}
	
}

void buttons_init(){
	
		//set as input
		clear_bit(DDRB, PB0);
		clear_bit(DDRB, PB3);
		clear_bit(DDRB, PB2);
		clear_bit(DDRB, PB1);
		
		clear_bit(DDRE, PE3);
		clear_bit(DDRE, PE4);
		clear_bit(DDRE, PE5);
		
		clear_bit(DDRD, PD2);
		clear_bit(DDRD, PD0);
		clear_bit(DDRD, PD1);
		clear_bit(DDRD, PD3);
		
		// set pullups
		set_bit(PORTB, PB0);
		set_bit(PORTB, PB3);
		set_bit(PORTB, PB2);
		set_bit(PORTB, PB1);
		
		set_bit(PORTE, PE3);
		set_bit(PORTE, PE4);
		set_bit(PORTE, PE5);
		
		set_bit(PORTD, PD2);
		set_bit(PORTD, PD0);
		set_bit(PORTD, PD1);
		set_bit(PORTD, PD3);
		
		calibrate_joysticks();
}
