/*
 * buttons.h
 *
 * Created: 10.04.2015 19:22:21
 *  Author: vebjornr
 */ 


#ifndef BUTTONS_H_
#define BUTTONS_H_

#include <inttypes.h>

#define INVERT_X_AXIS 1
#define INVERT_Y_AXIS 1
#define JOYSTICK_CENTER 511
#define JOYSTICK_CENTER_PADDING 0

typedef struct {
	
	uint8_t lights_near;
	uint8_t lights_far;
	uint8_t blink_right;
	uint8_t blink_left;
	uint8_t wiper;
	uint8_t horn;
	uint8_t phone;
	uint8_t joy_sw;
	uint8_t dead_mans_1;
	uint8_t dead_mans_2;
	uint8_t angel_eyes;
	uint8_t eyebrows;
	uint8_t brake;
	
	uint16_t volume;
	uint16_t fans;
	uint16_t joy_x;
	uint16_t joy_y;
	
} buttons_t;

void buttons_read(buttons_t *buttons);

void buttons_init(void);

void buttons_send_on_can(buttons_t *buttons);

uint8_t button_is_pressed(uint8_t button);

#endif /* BUTTONS_H_ */