/*
 * main.c
 *
 * Created: 09.04.2015 17:20:49
 *  Author: vebjornr
 */ 


#include "definitions.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include "can.h"
#include "USART.h"
#include "adc.h"
#include "timer.h"
#include "buttons.h"
#include "um_led.h"

volatile int clk_ticks = 0;
uint8_t can_send = 1;


uint8_t button_send_rate = 20; // Hz
uint8_t increment = 0;
buttons_t buttons;

uint8_t should_send_buttons(void);

int main(void)
{
	usart0_init(MYUBRR);
	adc_init(); 
	buttons_init();
	can_init();
	
	
	
	timer0_init();
	um_led_init();
	sei(); // enable global interrupts
	increment = 122/button_send_rate;
	
	usart0_puts("starting\n");
	um_led_set(LED_GREEN, ON);
	
    while(1)
    {
		
		
		if (!(clk_ticks % 6))
		{
			buttons_read(&buttons); // read buttons
						
			if (!button_is_pressed(buttons.dead_mans_1) || !button_is_pressed(buttons.dead_mans_2))
			{
				// neither of the dead-man switches are pressed! Driver is passed out. Set torque ref to neutral
				buttons.joy_y = FALLBACK_SPEED;
				
			}
			
			buttons_send_on_can(&buttons);
			
			um_led_toggle(LED_GREEN);
			//char lol[128];
			//sprintf(lol, "X: %d Y: %d F: %d V: %d\n", buttons.joy_x, buttons.joy_y, buttons.fans, buttons.volume);
			//usart0_puts(lol);
		}
		
    }
}

uint8_t should_send_buttons(){
	
	uint8_t temp = clk_ticks;
	uint8_t return_val = 0;

	
	for (uint8_t i = 0; i<123; i+=increment)
	{
		if(temp == i) return_val = 1;
	}

	if(can_send && return_val){
		can_send = 0;
		return 1;
	}
	
	if (return_val == 0)
	{
		can_send = 1;
	}
	
	return 0;
	
}


ISR(USART0_RX_vect)
{
	// Code to be executed when the USART receives a byte here
	//uint8_t b = UDR0;
	//usart0_putc(b);
	
}