/*
 * um_led.c
 *
 * Created: 18.04.2015 13:19:36
 *  Author: vebjornr
 */ 

#include <avr/io.h>
#include "um_led.h"

void um_led_init(void){
	
	DDRB |= (1<<LED_BLUE) | (1<<LED_GREEN) | (1<<LED_RED); // set leds as output
	PORTB |= (1<<LED_BLUE) | (1<<LED_GREEN) | (1<<LED_RED); // set all leds to off
	
}

void um_led_set(led_t led, led_state_t state){
	
	if(state == ON){
		PORTB &= ~(1<<led);
	} else if(state == OFF){
		PORTB |= (1<<led);
	}
		
}

void um_led_toggle(led_t led){
	
	PORTB ^= (1<<led);
	
}